=== debian/changelog ===
brewtarget (1.2.3-1.1ubuntu1) oneiric; urgency=low

  * Fix FTBFS (LP: #831250)
    - Add 05-ubuntu-phonon: Apply upstream SVN revisions 510 and 512.
      Then reorder the Phonon check so that it precedes the Qt4 check,
      and remove the check for the Phonon component from the Qt4 check.
      Unfortunately the upstream patch incorrectly attempts to link the
      wrong ${EXT_LIBRARIES} (instead of the correct ${EXT_LIBS}) when
      making the brewtarget executable, so fix that, too. Lastly, pass
      CMAKE_PREFIX_PATH in debian/rules.

 -- Daniel T Chen <crimsun@ubuntu.com>  Sat, 24 Sep 2011 21:17:54 -0400

brewtarget (1.2.3-1.1) unstable; urgency=low

  * Non-maintainer upload.
  * Fix build problem.

 -- Chris Taylor <ctaylor@debian.org>  Sat, 16 Apr 2011 06:37:02 +0000

brewtarget (1.2.3-1) unstable; urgency=low

  * 1.2.2 release.
  * New upstream release 1.2.3
  * Initial debian release (Closes: #538751)

 -- Philip G. Lee <rocketman768@gmail.com>  Sat, 01 Jan 2011 20:13:00 -0600
 
