=== debian/control ===
Source: brewtarget
Section: misc
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Philip G. Lee <rocketman768@gmail.com>
Build-Depends: cmake (>= 2.8), debhelper (>= 7.0.50), autotools-dev, libqt4-dev, qt4-qmake, libphonon-dev, libqtwebkit-dev
Standards-Version: 3.9.1
Homepage: http://brewtarget.sourceforge.net

Package: brewtarget
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: GUI beer brewing software
 Brewtarget is a calculator for brewing beer. It is a Qt-based program which
 allows you to create recipes from a database of ingredients. It calculates all
 the important parameters, helps you with mash temperatures, and just makes the
 process of recipe formulation much easier.
