## brewtarget 1.2.4

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -1,3 +1,8 @@
+# The current directory in the original source.
+INCLUDE_DIRECTORIES( ${CMAKE_CURRENT_SOURCE_DIR} )
+# The current directory in the output build directory.
+INCLUDE_DIRECTORIES( ${CMAKE_CURRENT_BINARY_DIR} )
+
 # Put all the required Qt dirs in the includes.
 INCLUDE(${QT_USE_FILE})
 
@@ -8,8 +13,14 @@
     ${SRCDIR}/BeerXMLElement.cpp
     ${SRCDIR}/BrewDayWidget.cpp
     ${SRCDIR}/BrewDayScrollWidget.cpp
+    ${SRCDIR}/brewnote.cpp
+    ${SRCDIR}/BrewNoteWidget.cpp
+    ${SRCDIR}/BrewTargetTreeItem.cpp
+    ${SRCDIR}/BrewTargetTreeModel.cpp
+    ${SRCDIR}/BrewTargetTreeView.cpp
     ${SRCDIR}/BeerColorWidget.cpp
     ${SRCDIR}/brewtarget.cpp
+    ${SRCDIR}/BtSplashScreen.cpp
     ${SRCDIR}/CelsiusTempUnitSystem.cpp
     ${SRCDIR}/ColorMethods.cpp
     ${SRCDIR}/ConverterTool.cpp
@@ -73,6 +84,7 @@
     ${SRCDIR}/TimerWidget.cpp
     ${SRCDIR}/TimeUnitSystem.cpp
     ${SRCDIR}/unit.cpp
+    ${SRCDIR}/UnitSystem.cpp
     ${SRCDIR}/UnitSystems.cpp
     ${SRCDIR}/USVolumeUnitSystem.cpp
     ${SRCDIR}/USWeightUnitSystem.cpp
@@ -100,6 +112,8 @@
     ${UIDIR}/aboutDialog.ui
     ${UIDIR}/brewDayWidget.ui
     ${UIDIR}/brewDayScrollWidget.ui
+    ${UIDIR}/brewNoteWidget.ui
+    ${UIDIR}/btSplashScreen.ui
     ${UIDIR}/converterTool.ui
     ${UIDIR}/mainWindow.ui
     ${UIDIR}/mashStepEditor.ui
@@ -138,7 +152,11 @@
     ${SRCDIR}/BeerColorWidget.h
     ${SRCDIR}/BrewDayWidget.h
     ${SRCDIR}/BrewDayScrollWidget.h
+    ${SRCDIR}/BrewNoteWidget.h
+    ${SRCDIR}/BrewTargetTreeModel.h
+    ${SRCDIR}/BrewTargetTreeView.h
     ${SRCDIR}/BtDigitWidget.h
+    ${SRCDIR}/BtSplashScreen.h
     ${SRCDIR}/ConverterTool.h
     ${SRCDIR}/EquipmentComboBox.h
     ${SRCDIR}/EquipmentEditor.h
@@ -191,81 +209,33 @@
     ${SRCDIR}/YeastTableWidget.h
 )
 
-# List of documentation files to be installed.
-SET( brewtarget_DOCS
-     ${ROOTDIR}/README
-#     ${ROOTDIR}/COPYING.GPLv3
-#     ${ROOTDIR}/COPYING.WTFPL
-     ${ROOTDIR}/COPYRIGHT
-     ${ROOTDIR}/doc/manual/index.html
-)
-
-# List of data files to be installed.
-SET( brewtarget_DATA
-     ${DATADIR}/database.xml
-     ${DATADIR}/mashs.xml
-     ${DATADIR}/options.xml
-     ${DATADIR}/recipes.xml
-)
-
-# Desktop files to install.
-SET( brewtarget_DESKTOP
-     ${ROOTDIR}/brewtarget.desktop
-)
-
-# Icon files to install.
-SET( brewtarget_ICONS
-     ${ROOTDIR}/images/BrewtargetIcon.png
-)
-
-SET( TRANSLATIONS_FILES
-     ${TRANSLATIONSDIR}/bt_cs.ts # Czech
-     ${TRANSLATIONSDIR}/bt_de.ts # German
-     ${TRANSLATIONSDIR}/bt_en.ts # English
-     ${TRANSLATIONSDIR}/bt_es.ts # Spanish
-     ${TRANSLATIONSDIR}/bt_fr.ts # French
-     ${TRANSLATIONSDIR}/bt_pl.ts # Polish
-     ${TRANSLATIONSDIR}/bt_pt.ts # Portuguese
-)
-
 SET( FILES_TO_TRANSLATE
      ${brewtarget_SRCS}
      ${brewtarget_UIS}
 )
 
-SET( RCFILE ${WINDIR}/icon.rc )
-
-SET( brewtarget_SOUNDS
-     ${DATADIR}/sounds/45minLeft.mp3
-     ${DATADIR}/sounds/addFuckinHops.mp3
-     ${DATADIR}/sounds/aromaHops.mp3
-     ${DATADIR}/sounds/bitteringHops.mp3
-     ${DATADIR}/sounds/checkBoil.mp3
-     ${DATADIR}/sounds/checkFirstRunnings.mp3
-     ${DATADIR}/sounds/checkGravity.mp3
-     ${DATADIR}/sounds/checkHydrometer.mp3
-     ${DATADIR}/sounds/checkMashTemps.mp3
-     ${DATADIR}/sounds/checkTemp.mp3
-     ${DATADIR}/sounds/clarifyingAgent.mp3
-     ${DATADIR}/sounds/cleanup.mp3
-     ${DATADIR}/sounds/closeFuckinValves.mp3
-     ${DATADIR}/sounds/closeValves.mp3
-     ${DATADIR}/sounds/doughIn.mp3
-     ${DATADIR}/sounds/drinkAnotherHomebrew.mp3
-     ${DATADIR}/sounds/drinkHomebrew.mp3
-     ${DATADIR}/sounds/emptyMashTun.mp3
-     ${DATADIR}/sounds/extraPropane.mp3
-     ${DATADIR}/sounds/flameout.mp3
-     ${DATADIR}/sounds/flavorHops.mp3
-     ${DATADIR}/sounds/heatWater.mp3
-     ${DATADIR}/sounds/mashHops.mp3
-     ${DATADIR}/sounds/pitchYeast.mp3
-     ${DATADIR}/sounds/sanitize.mp3
-     ${DATADIR}/sounds/sparge.mp3
-     ${DATADIR}/sounds/startBurner.mp3
-     ${DATADIR}/sounds/startChill.mp3
-     ${DATADIR}/sounds/stirMash.mp3
-)
+#==============================Setup the config.h==============================
+
+# "#define CONFIGDATADIR ${CONFIGDATADIR}$" in config.in will be replaced
+# by the below corresponding value in ${CONFIGDATADIR} below when
+# CONFIGURE_FILE() is called.
+IF( IS_ABSOLUTE ${DATAPATH} )
+   SET( CONFIGDATADIR "${DATAPATH}/" )
+ELSE()
+   SET( CONFIGDATADIR "/${DATAPATH}/" )
+ENDIF()
+
+IF( IS_ABSOLUTE ${DOCPATH} )
+   SET( CONFIGDOCDIR "${DOCPATH}/" )
+ELSE()
+   SET( CONFIGDOCDIR "/${DOCPATH}/" )
+ENDIF()
+
+# Tell cmake where the configure file is and where
+# to put the output. All variables in config.in written as "${VAR}$
+# will be replaced by VAR as determined by cmake in config.h.
+# Outputs only in the build directory.
+CONFIGURE_FILE( config.in config.h )
 
 #==================================Qt Junk=====================================
 
@@ -294,63 +264,56 @@
 # the translations as a dependency for the executable later.
 ADD_CUSTOM_TARGET(translations DEPENDS ${QM_FILES})
 
-#===============================Packaging======================================
-
-# NOTE: For now, this only calls CPack when we are unix. Need to add support
-# for apple bundles and microsoft NSIS installer.
-#
-# To make the packages, "make package". For source packages, "make package_source"
-IF(EXISTS "${CMAKE_ROOT}/Modules/CPack.cmake" AND UNIX AND NOT APPLE)
-  MESSAGE(STATUS "CMakeRoot: ${CMAKE_ROOT}/Modules/CPack.cmake")
-
-  SET(CPACK_SET_DESTDIR "on")
-  SET(CPACK_PACKAGING_INSTALL_PREFIX "/tmp")
-  SET(CPACK_SOURCE_GENERATOR "TBZ2;")
-  SET(CPACK_SOURCE_IGNORE_FILES 
-      "/.svn/"
-      "~$"
-      "/CMakeFiles/"
-      "/_CPack_Packages/"
-      "^brewtarget.*deb$"
-      "^brewtarget.*rpm$"
-      "^brewtarget.*tar.*$"
-      "CPack.*"
-      "Makefile"
-      "cmake_install.*"
-      "\\\\.o$"
-      "/brewtarget.dir/"
-      "moc_.*"
-      "qrc_brewtarget.*"
-      "ui_.*h"
-      "install_manifest.*"
-      "config\\\\.h"
+#============================Icon for Windows==================================
+
+IF( WIN32 AND MINGW )
+  ADD_CUSTOM_COMMAND(OUTPUT ${WINDIR}/icon.o
+                     COMMAND windres.exe -I${CMAKE_CURRENT_SOURCE_DIR}
+                     -i${RCFILE}
+                     -o${WINDIR}/icon.o
+                     DEPENDS ${RCFILE}
   )
-
-  SET( CPACK_PACKAGE_VERSION ${brewtarget_VERSION_STRING} )
-  SET( CPACK_PACKAGE_VENDOR  "Philip G. Lee" )
-  SET( CPACK_PACKAGE_CONTACT "Philip G. Lee <rocketman768@gmail.com>" )
-  SET( CPACK_PACKAGE_DESCRIPTION_SUMMARY "GUI beer brewing software" )
-  SET( CPACK_PACKAGE_DESCRIPTION "Brewtarget is a calculator for brewing beer. It is a Qt-based program which
-       allows you to create recipes from a database of ingredients. It calculates all
-       the important parameters, helps you with mash temperatures, and just makes the
-       process of recipe formulation much easier." )
-
-#	SET(CPACK_RESOURCE_FILE_LICENSE		${CMAKE_CURRENT_SOURCE_DIR}//COPYING)
-  SET(CPACK_PACKAGE_VERSION_MAJOR       ${brewtarget_VERSION_MAJOR})
-  SET(CPACK_PACKAGE_VERSION_MINOR       ${brewtarget_VERSION_MINOR})	# to create a debian confirm file-version-string
-  SET(CPACK_PACKAGE_FILE_NAME           "${CMAKE_PROJECT_NAME}_${brewtarget_VERSION_STRING}_${CMAKE_SYSTEM_PROCESSOR}")
-  SET(CPACK_SOURCE_PACKAGE_FILE_NAME    "${CMAKE_PROJECT_NAME}_${brewtarget_VERSION_STRING}_source")
-  SET(CPACK_PACKAGE_EXECUTABLES "${brewtarget_EXECUTABLE}" "Brewtarget" )
-  #SET(CPACK_STRIP_FILES TRUE)
-  SET(CPACK_COMPONENTS_ALL Libraries ApplicationData)
-
- #===========================UNIX======================================
- IF(UNIX)
-  SET(CPACK_GENERATOR "DEB;RPM;TBZ2;")
-
-  #-----------------DEB----------------
-  SET( CPACK_DEBIAN_PACKAGE_MAINTAINER "Philip G. Lee <rocketman768@gmail.com>" )
-  # NOTE: Use the getdependencies script to get the dependencies!
-  SET( CPACK_DEBIAN_PACKAGE_DEPENDS "libc6 (>= 2.3.6-6~), libc6 (>= 2.4), libgcc1 (>= 1:4.1.1), libphonon4 (>= 4:4.2.0), libqt4-dbus (>= 4:4.5.3), libqt4-svg (>= 4:4.5.3), libqt4-webkit (>= 4:4.5.3), libqt4-xml (>= 4:4.5.3), libqtcore4 (>= 4:4.6.1), libqtgui4 (>= 4:4.5.3), libstdc++6 (>= 4.1.1), libx11-6, phonon (>= 4:4.5.2)" )
-
-  SET( CPACK_DEBIAN_PACKAGE_SECTION "misc" )
+  SET(brewtarget_SRCS ${brewtarget_SRCS} ${WINDIR}/icon.o)
+ELSEIF(WIN32)
+  SET(brewtarget_SRCS ${brewtarget_SRCS} ${RCFILE})
+ENDIF()
+
+#===========================Create the binary==================================
+
+ADD_EXECUTABLE( ${brewtarget_EXECUTABLE} ${brewtarget_SRCS} ${brewtarget_MOC_SRCS} ${brewtarget_QRC_CPP} ${brewtarget_UIS_H} )
+ADD_DEPENDENCIES( ${brewtarget_EXECUTABLE} translations )
+
+# Link brewtarget against appropriate libraries.
+IF( WIN32 AND MINGW )
+   ############################################################################
+   # Need to set some linker flags that I don't know how to get
+   # automatically.
+   ############################################################################
+
+   # MinGW-specific flags.
+   #    '-Wl,-subsystem,windows' supresses the output command window.
+   #    '-Wl,-s' strips the executable of symbols.
+   SET_TARGET_PROPERTIES( ${brewtarget_EXECUTABLE} PROPERTIES LINK_FLAGS "-enable-stdcall-fixup -Wl,-enable-auto-import -Wl,-enable-runtime-pseudo-reloc -mthreads -Wl,-subsystem,windows")
+ENDIF()
+
+# Link brewtarget against Qt libraries defined by QT_LIBRARIES
+TARGET_LINK_LIBRARIES( ${brewtarget_EXECUTABLE} ${QT_LIBRARIES} ${EXT_LIBRARIES} )
+MESSAGE( STATUS "Libraries: ${QT_LIBRARIES} ${EXT_LIBRARIES}" )
+
+#=================================Installs=====================================
+
+# Install executable.
+INSTALL( TARGETS ${brewtarget_EXECUTABLE}
+         RUNTIME DESTINATION ${TARGETPATH} )
+
+# Install the translations.
+INSTALL(FILES ${QM_FILES}
+        DESTINATION "${DATAPATH}/translations_qm")
+
+IF( APPLE )
+   # This SHOULD run macdeployqt on the app bundle at install time.
+   # Don't know if it works. Could someone try?
+   # May have to add a WORKING_DIRECTORY.
+   INSTALL( CODE
+            "EXECUTE_PROCESS( COMMAND ${QT_BINARY_DIR}/macdeployqt ${BT_BUNDLE_DIR} )" )
+ENDIF()
