=== debian/changelog ===
brewtarget (1.2.4-1) unstable; urgency=low

  * New upstream release
  * Added build-dep on libqtwebkit-dev

 -- Philip G. Lee <rocketman768@gmail.com>  Sun, 02 Oct 2011 12:23:44 -0500
