=== debian/control ===
--- 
+++ 
@@ -1,10 +1,9 @@
 Source: brewtarget
 Section: misc
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Philip G. Lee <rocketman768@gmail.com>
+Maintainer: Philip G. Lee <rocketman768@gmail.com>
 Build-Depends: cmake (>= 2.8), debhelper (>= 7.0.50), autotools-dev, libqt4-dev, qt4-qmake, libphonon-dev, libqtwebkit-dev
-Standards-Version: 3.9.1
+Standards-Version: 3.9.2
 Homepage: http://brewtarget.sourceforge.net
 
 Package: brewtarget
