=== debian/rules ===
--- 
+++ 
@@ -5,7 +5,7 @@
 	if ! test -d build; then mkdir build; fi
 	if ! test -d build/cmake; then mkdir build/cmake; fi
 	cd build/cmake; \
-	cmake ../../ -DDO_RELEASE_BUILD=ON -DCMAKE_INSTALL_PREFIX=$(install-dir) -DEXEC_PREFIX=/usr -DCMAKE_PREFIX_PATH=/usr/include/phonon
+	cmake ../../ -DDO_RELEASE_BUILD=ON -DCMAKE_INSTALL_PREFIX=$(install-dir) -DEXEC_PREFIX=usr
 
 override_dh_auto_build:
 	cd build/cmake; \
@@ -23,3 +23,4 @@
 
 %:
 	dh $@
+
